<?php
define( '_VALID', 1 );
session_start();
require_once('../../engine/admin.php');

if (!isset($_GET['f']) || empty($_GET['f'])) {
  die($LANG->_('Please specify file name for download.'));
}
// Nullbyte hack fix
if (strpos($_GET['f'], "\0") !== FALSE) die('');

// Get real file name.
// Remove any path info to avoid hacking by adding relative path, etc.
$fname = basename($_GET['f']);

$file_path = $Config_root_dir.'/cache/backup/'.$fname;

if (!is_file($file_path)) {
  die($LANG->_('File does not exist. Make sure you specified correct file name.')); 
}

// file size in bytes
$fsize = filesize($file_path); 
if( $fsize > 51200 ){ // > 50 Kb
	$mtype = 'application/x-gzip';
	$fext = '.sql.gz';
	$file = @fopen($file_path,"r");
	$contain = '';
	while(!feof($file)) {
	  $contain .= fread($file, 1024*8);
	}
	@fclose($file);
	file_put_contents($file_path.$fext,gzencode($contain));
	
	//@unlink($file_path);
	$fsize = filesize($file_path.$fext);
	$file_path = $file_path.$fext;
}else{
	// file extension
	$fext = '.sql';
	$mtype = 'text/x-sql';
}
$fdown_name = $fname.$fext;

// set headers
header("Pragma: public");
header("Expires: 0");
header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
header("Cache-Control: public");
header("Content-Description: File Transfer");
header("Content-Type: $mtype");
header("Content-Disposition: attachment; filename=\"$fdown_name\"");
header("Content-Transfer-Encoding: binary");
header("Content-Length: " . $fsize);

// download
// @readfile($file_path);
$file = @fopen($file_path,"rb");
if ($file) {
  while(!feof($file)) {
    print(fread($file, 1024*8));
    flush();
    if (connection_status()!=0) {
      @fclose($file);
      die();
    }
  }
  @fclose($file);
}
//@unlink($file_path);
?>