<?php
class creatTemplate {

	var $page = NULL;
	var $template = NULL;
	var $search = array();
	var $elements = array();

	function load_template($template,$page) {
		global $Config_root_dir;
		$this->path = $Config_root_dir.'/templates/'.$template.'/'.$page.'.tpl';
		if ( $template=='' || $page=='' || !file_exists($this->path) ){
			echo('The path <B><font color=#FF0000>'.$this->path.'</font></B> is not exist!');
			return false;
		}
		$this->template = $template;
		$this->page = file_get_contents($this->path);
		return true;
	}

	function set_replace($search, $php_format, $echo_format, $string_format){
		$this->replaces[] = array($search, $php_format, $echo_format, $string_format);
	}
	
	function set_element($start_tag, $end_tag, $callback, $attribute = NULL){
		$this->elements[] = array($start_tag, $end_tag, $callback, $attribute);
	}

	function compile(){
		if($this->page=='') return false;
		
		$this->outpage = $this->page;
		foreach((array)$this->elements as $element){
			$start_tag	=	$element[0];
			$end_tag	=	$element[1];
			$callback	=	$element[2];
			$attribute	=	$element[3];
			$fixpage = $this->outpage;
			if($attribute=='numeric'){
				$start = $offset_start_outpage=0;
				while( false!==($start = strpos($fixpage,$start_tag,$start)) ){
					$i = $p = $start+strlen($start_tag);$num='';
					while(is_numeric($fixpage{$i})){$num .= $fixpage{$i};$i++;}
					if($i == $p) {$start++;continue;}
					if($fixpage{$i} != '>') continue;
					$end = strpos($fixpage,$end_tag.$num.'>',$start);
					if($end === false) break;
					$length = $end-$start+strlen($end_tag.$num.'>');
					$string = $callback(substr($fixpage,$start,$length));
					$this->outpage = substr_replace($this->outpage,$string,$start+$offset_start_outpage,$length);
					$offset_start_outpage += strlen($string)-$length;
					$start++;
				}
			}else{
				$start = $offset_start_outpage=0;
				while( false!==($start = strpos($fixpage,$start_tag,$start)) ){
					$end = strpos($fixpage,$end_tag,$start);
					if($end === false) break;
					$length = $end-$start+strlen($end_tag);
					$string = $callback(substr($fixpage,$start,$length));
					$this->outpage = substr_replace($this->outpage,$string,$start+$offset_start_outpage,$length);
					$offset_start_outpage += strlen($string)-$length;
					$start++;
				}
			}
		}
		$start = 0;
		while( false!==($start = strpos($this->outpage,'<?',$start)) ){
			$end = strpos($this->outpage,'?>',$start);
			if($end === false) break;
			$phptag_pos[] = array($start,$end);
			$start=$end+1;
		}
		$start = 0;
		while( false!==($start = strpos($this->outpage,'<<<LINKSFORMAT',$start)) ){
			$end = strpos($this->outpage,'LINKSFORMAT;',$start);
			if($end === false) break;
			$heredoc_pos[] = array($start,$end);
			$start=$end+1;
		}
		
		foreach((array)$this->replaces as $replace){
			$search = $replace[0];
			$php_format = $replace[1];
			$echo_format = $replace[2];
			$string_format = $replace[3];
			$length = strlen($search);
			$fixpage = $this->outpage;
			$pos = $offset_start_outpage=0;
			while( false!==($pos = strpos($fixpage,$search,$pos)) ){
				$find = false;
				foreach((array)$heredoc_pos as $heredoc){
					if($pos > $heredoc[0] && $pos < $heredoc[1]){
						$this->outpage = substr_replace($this->outpage,$string_format,$pos+$offset_start_outpage,$length);
						$offset_start_outpage += strlen($string_format)-$length;
						$pos++;
						$find = true;
						break;
					}
				}
				if($find) break;
				foreach((array)$phptag_pos as $phptag){
					if($pos > $phptag[0] && $pos < $phptag[1]){
						$this->outpage = substr_replace($this->outpage,$echo_format,$pos+$offset_start_outpage,$length);
						$offset_start_outpage += strlen($echo_format)-$length;
						$pos++;
						$find = true;
						break;
					}
				}
				if($find) break;
				$this->outpage = substr_replace($this->outpage,$php_format,$pos+$offset_start_outpage,$length);
				$offset_start_outpage += strlen($php_format)-$length;
				$pos++;
			}
		}
		return $this->outpage;
	}
	
	function __destruct(){ 
		$this->template = NULL;
		$this->page = NULL;
	}
}


function write_to_cache($template,$pages,$data=''){
	global $Config_root_dir;
	
	$valid_pages = array('index','sendlink','source','archive','contactus','statistic','about','terms','single');
	foreach((array)$pages as $page){
		if(false === array_search($page,$valid_pages)) return false;
		
		$tpl = new creatTemplate;
		if( $data==''){
			$result = $tpl->load_template($template,$page);
			if(!$result) return false;
		}
		else{
			$tpl->template = $template;
			$tpl->page = $data;
		}
		$tpl->set_replace('<-Keywords->', '<?php echo $Config_MetaKeys; ?>', ' echo $Config_MetaKeys; ', '{$Config_MetaKeys}');
		$tpl->set_replace('<-Description->', '<?php echo $Config_MetaDesc; ?>', ' echo $Config_MetaDesc; ', '{$Config_MetaDesc}');
		$tpl->set_replace('<-SiteTitle->', '<?php echo $Config_SiteTitle; ?>', ' echo $Config_SiteTitle; ', '{$Config_SiteTitle}');
		$tpl->set_replace('<-Theme->', 'templates/'.$template.'/<?php echo $clr; ?>', ' echo "templates/'.$template.'/".$clr; ', 'templates/'.$template.'/{$clr}');
		$tpl->set_replace('<-OtherStyle->', '<?php otherstyle("'.$page.'"); ?>', ' otherstyle("'.$page.'"); ', ' otherstyle("'.$page.'") ');
		if(file_exists($Config_root_dir.'/engine/classes/'.$page.'.php'))
			include_once($Config_root_dir.'/engine/classes/'.$page.'.php');
		$CacheCode = $tpl->compile().base64_decode("DQo8IS0tIExpbmtCb3ggQ01TIENvcHlyaWdodCB2ZXIgMy4xIChodHRwOi8vTWVocmRhZERlc2lnbi5Db20pIC0tPg0K");
		$tpl->__destruct();

		$file	=	$Config_root_dir.'/cache/'.$page.'.tpl';
		$open	=	fopen($file,"w");
		if (! fwrite($open,$CacheCode,strlen($CacheCode)) ) return false;
		fclose($open);
	}
	return true;
}
?>