<?php
function security(){
	global $Config_live_site;
$REQUEST_URL	= 	parse_url($_SERVER['REQUEST_URI']);
if ( @$REQUEST_URL['query'] != '' ) :
$PageAddress	=	$REQUEST_URL['query'];
$characters		=	array('+','`','$','/','\\','"','\'',' ','*','-','');
$array_count	=	count($characters)	;
for ( $i = 0 ; $i < $array_count ; $i++ ){
	if ( @substr_count($PageAddress,$characters[$i]) >= 1 ){
		exit(header('location: '.$Config_live_site.'/warning.php?err=hack'));
		break;
		}
	}
endif;
}

function color_skin(){
	global $Config_skin,$Config_default_color;
	
	$default_color = ($Config_default_color=='10')? 'default':intval($Config_default_color);
	
	$clr = $_COOKIE['LBCMS_clr'];
	if($clr != ''){
		if(!is_numeric($clr)) return $default_color;
		if( is_dir('templates/'.$Config_skin.'/'.$clr) ) return $clr;
		else return $default_color;
	}else{
		$clr = $_GET['c'];
		if(!is_numeric($clr)) return $default_color;
		setcookie( 'LBCMS_clr', $clr, time()+86400 );
		if( is_dir('templates/'.$Config_skin.'/'.$clr)) return $clr;
		else return $default_color;
	}
}

// get domain from URL without http:// and www. and etc
//i.e http://user:pass@www.mysite.com:8080/newpage.htm?id=5#fragment convert to mysite.com
function getDomainFromURL( $url ) { return preg_replace('%(?:https?://)?(?:[^@]+@)?(?:www\.)?([^/:]+).*%i','$1',$url); }
function NeedProtocol( &$url ) {
	if (! preg_match('%^https?://.*%i', $url) )
		$url = 'http://' . $url;
	return $url;
}
function IsValidUsername( $user ) { return preg_match('/^([a-z0-9_\.\-]{6,35})$/i',$user); }
function IsValidEmail( $mail ) { return preg_match("/^[\w\.\-]+@\w+[\w\.\-]*?\.\w{1,4}$/i", $mail ); }
function IsValidName( $string ) {
	/*
	 * The following regular expression blocks all strings containing any low control characters:
	 * 0x00-0x1F, 0x7F
	 * These should be control characters in almost all used charsets.
	 * The high control chars in ISO-8859-n (0x80-0x9F) are unused (e.g. http://en.wikipedia.org/wiki/ISO_8859-1)
	 * Since they are valid UTF-8 bytes (e.g. used as the second byte of a two byte char),
	 * they must not be filtered.
	 */
	$invalid = preg_match( '/[\x00-\x1F\x7F]/', $string );
	if ($invalid) return false;

	return true;
}

/*
* Utility function to return a value from a named array or a specified default
* value of $mask is:
* none or only addslashes		= 0
* trim + strip tags + sql quote	= 7
*/
define( 'TRIM_SPACE', 0x0001 );
define( 'STRIP_HTML', 0x0002 );
define( 'SQL_QUOTE', 0x0004 );
function GetParam( $arr, $name, $def='', $mask=7 ){
	if ( is_null($arr[$name]) ) return NULL;
	if ( $arr[$name] == '' ) return $def;
	if ( is_numeric($arr[$name]) ) return intval($arr[$name]);
	
	if ( is_string($arr[$name]) ){
		if ( $mask & TRIM_SPACE ){
			$arr[$name] = trim( $arr[$name] ); 
		}
		if ( $mask & STRIP_HTML ){
//				$arr[$name] = htmlspecialchars( $arr[$name] );
			$arr[$name] = strip_tags( $arr[$name] );
		}
		if( $mask & SQL_QUOTE ){
			$arr[$name] = mysql_real_escape_string( $arr[$name] );
		}elseif (! @get_magic_quotes_gpc() ){
			$arr[$name] = addslashes( $arr[$name] );
		}
	}
	return $arr[$name];
}

function CreatePassword($length=6,$allchr=true) {
	if($allchr)
		 $salt = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
	else $salt = '23456789bcdfghjkmnpqrstvwxyz';
	$saltlen = strlen($salt)-1;
	$createpass='';
	mt_srand(10000000*(double)microtime());
	for ($i = 0; $i < $length; $i++)
		$createpass .= $salt[mt_rand(0,$saltlen)];
	return $createpass;
}

function paginate( $totalpages, $url, $getpage='p', $extension='' ) {
	global $LANG;
	$currentpage = (is_numeric($_GET[$getpage]) && $_GET[$getpage]>=0) ? $_GET[$getpage] : 0;
	if($currentpage <= 0){
		echo '<span class="page"><a class="disabled" title="'.$LANG->_('Go To Previous Page').'">'.$LANG->_('Previous').'</a></span>' . "\n";
	}else{
		echo '<span class="page"><a href="javascript: void(0);" onClick="show2(\'' . $url . ($currentpage - 1) . $extension . '\',null,null,\'index\');" title="'.$LANG->_('Go To Previous Page').'">'.$LANG->_('Previous').'</a></span>' . "\n";
	}
	
	$start1=0;
	$numShowPages1=$totalpages;
	$start2=0;
	$numShowPages2=0;
	if($totalpages > 10){
		$oneThird = floor($totalpages/3);
		$twoThirds = $oneThird*2;
		if($currentpage < 4){
			$start1=0;
			$numShowPages1=7;
			$start2=$totalpages-3;
			$numShowPages2=$totalpages;
		}elseif($currentpage < $oneThird){
			$start1=$currentpage-3;
			$numShowPages1=$currentpage+4;
			$start2=($numShowPages1 < $totalpages-3)?$totalpages-3:$numShowPages1;
			$numShowPages2=$totalpages;
		}elseif($currentpage < $twoThirds+5 ){
			$start1=$currentpage-2;
			$numShowPages1=($currentpage+3 < $totalpages) ? $currentpage+3:$totalpages;
			$start2=($numShowPages1 < $totalpages-5)?$totalpages-5:$numShowPages1;
			$numShowPages2=$totalpages;
		}else{
			$start1=0;
			$numShowPages1=3;
			$start2=$totalpages-7;
			$numShowPages2=$totalpages;
		}
		$start1 -= 10-(($numShowPages1-$start1)+($numShowPages2-$start2));
	}
	
	
	for ( ; $start1 < $numShowPages1 ; $start1++ ){
		$pagenumber = $start1+1;
		if($start1 == $currentpage){
			echo '<span class="page"><a class="disabled" title="'.$LANG->_('Currently On Page') . $pagenumber . '">' . $pagenumber . '</a></span>' . "\n";
		}else{
			echo '<span class="page"><a href="javascript: void(0);" onClick="show2(\'' . $url . $start1 . $extension . '\',null,null,\'index\');" title="'.$LANG->_('Go To Page ') . $pagenumber . '">' . $pagenumber . '</a></span>' . "\n";
		}
	}
	if($totalpages > 10 && $start2 < $numShowPages2) echo '<span>......</span>' . "\n";
	for ( ; $start2 < $numShowPages2 ; $start2++ ){
		$pagenumber = $start2+1;
		if($start2 == $currentpage){
			echo '<span class="page"><a class="disabled" title="'.$LANG->_('Currently On Page') . $pagenumber . '">' . $pagenumber . '</a></span>' . "\n";
		}else{
			echo '<span class="page"><a href="javascript: void(0);" onClick="show2(\'' . $url . $start2 . $extension . '\',null,null,\'index\');" title="'.$LANG->_('Go To Page ') . $pagenumber . '">' . $pagenumber . '</a></span>' . "\n";
		}
	}
	
	if($currentpage >= $totalpages-1){
		echo '<span class="page"><a class="disabled" title="'.$LANG->_('Go To Next Page').'">'.$LANG->_('Next').'</a></span>' . "\n";
	}else{
		echo '<span class="page"><a href="javascript: void(0);" onClick="show2(\'' . $url . ($currentpage + 1) . $extension . '\',null,null,\'index\');" title="'.$LANG->_('Go To Next Page').'">'.$LANG->_('Next').'</a></span>' . "\n";
	}
}
function showing_Rows_Options($url,$rows,$orders,$default_order,$default_sort){
	global $LANG;
	echo '<form action="'.$url.'" name="showing_Rows_Options" method="post" onsubmit="sendcontent(this,\'index\');return false;">';
	$LANG->_e('rows');
	echo ' : <input type="text" maxlength="3" name="rows" class="inputs" style="width:20px" value="'.$rows.'" /> ';
	$LANG->_e('sort by');
	echo ' : <select name="order" class="inputs" style="width: 100px ;" >';
	foreach($orders as $sqlname=>$htmlname){
		echo '<option value="'.$sqlname.'" ';
		if($sqlname==$default_order) echo ' selected="selected" ';
		echo '>'.$htmlname.'</option>';
	}
	echo '</select>';
	$LANG->_e('direct');
	echo ' : <select name="sort" class="inputs" style="width: 100px ;" >';
	echo '<option value="ASC"'.($default_sort=='ASC'?' selected="selected" ':'').'>'.$LANG->_('ASC').'</option>';
	echo '<option value="DESC"'.($default_sort=='DESC'?' selected="selected" ':'').'>'.$LANG->_('DESC').'</option></select>';
	echo '<input type="submit" name="submit" value="'.$LANG->_('ok').'" class="button" /></form>';
}
function rows_Options($all_order,&$rows,&$sort,&$order,&$orderby){
	$rows	=	(int)GetParam($_REQUEST,'rows');
	$order	=	GetParam($_REQUEST,'order');
	if ($order){
		$sort	=	(GetParam($_REQUEST,'sort')=='DESC')?'DESC':'ASC';
		if( false === array_key_exists($order,$all_order) ){
			$wanted = '25,id,DESC';
			$orderby = '`id` DESC';
			$order	=	'id';
		}else{
			$wanted = $rows.','.$order.','.$sort;
			$orderby = '`'.$order.'` '.$sort;
		}
		setcookie( 'LB[wanted]', $wanted, time()+86400, '/' );
	}else if(($wanted=$_COOKIE['LB']['wanted'])){
		$settings = explode(',',$wanted);
		$rows = (int)$settings[0];
		$sort	=	($settings[2]=='DESC')?'DESC':'ASC';
		if( false === array_key_exists($settings[1],$all_order) ){
			$order	=	'id';
			$orderby = '`id` DESC';
		}else{
			$order	=	$settings[1];
			$orderby = '`'.$order.'` '.$sort;
		}
	}else{
		$rows = 25;
		$order	=	'id';
		$sort	=	'DESC';
		$orderby = '`id` DESC';
	}
	if($rows == 0)$rows = 25;
	return (GetParam($_GET,'start_row') * $rows);
}

function SendMail( $to, $subject, $message, $ishtml=FALSE, $cc=NULL, $bcc=NULL, $attachment=NULL, $replyto=NULL, $replytoname=NULL ) {
	global $Config_mailfrom, $Config_fromname;
	global $Config_sendmail, $Config_mailer;
	global $Config_smtpauth, $Config_smtpuser, $Config_smtppass, $Config_smtphost, $Config_smtpport;
	if ( empty($Config_mailer) or $Config_mailer == 'disable' ) return false;
	// Filter mailfrom, fromname and subject
	if ( isset($Config_mailfrom) and !IsValidEmail( $Config_mailfrom ) ) return false;
	if ( isset($Config_fromname) and !IsValidName( $Config_fromname ) ) return false;
	if ( !IsValidName( $subject ) ) return false;

	require_once 'classes/class-phpmailer.php';
	require_once 'classes/class-smtp.php';
	$phpmailer = new PHPMailer();
	
	$phpmailer->CharSet 	= "utf-8";
//	$phpmailer->Hostname = $domain;//"mail.yourdomain.com"
	$phpmailer->Mailer 	= $Config_mailer;
	// Add smtp values if needed
	if ( $Config_mailer == 'smtp' ) {
		$phpmailer->SMTPAuth = (bool)$Config_smtpauth;
		$phpmailer->Username = $Config_smtpuser;
		$phpmailer->Password = $Config_smtppass;
		$phpmailer->Host 	= $Config_smtphost;
		$phpmailer->Port 	= ($Config_smtpport)?$Config_smtpport:25;
	} else

	// Set sendmail path
	if ( $Config_mailer == 'sendmail' ) {
		if (isset($Config_sendmail))
			$phpmailer->Sendmail = $Config_sendmail;
	} // if

	$phpmailer->FromName = isset($Config_fromname)? $Config_fromname : 'LinkBoxCMS';
	
	/* If we don't have an email from the config settings default to linkboxcms@$sitename
	 * Some hosts will block outgoing mail from this address if it doesn't exist but
	 * there's no easy alternative. Defaulting to admin_email might appear to be another
	 * option but some hosts may refuse to relay mail from an unknown domain.
	 */

	if ( isset($Config_mailfrom) ) 
		$mailfrom = $Config_mailfrom;
	else{
		// Get the site domain and get rid of www.
		$sitename = $_SERVER['SERVER_NAME'];
		$www = strtolower( substr( $sitename, 0, 4 ) );
		if ( $www == 'www.' ) $sitename = substr( $sitename, 4 );
		$mailfrom = 'linkboxcms@' . $sitename;
	}
	
	$phpmailer->From 	= $mailfrom;	
	$phpmailer->Subject = $subject;
	$phpmailer->Body 	= $message;

	// activate HTML formatted emails
	$phpmailer->IsHTML((bool)$ishtml);

	// Set destination addresses
	if (!IsValidEmail( $to )) return false;
	$phpmailer->AddAddress( $to );

	// Add any CC and BCC recipients
	if (isset( $cc )) {
		foreach ( (array) $cc as $recipient ) {
			if (!IsValidEmail( $recipient )) return false;
			$phpmailer->AddCC( $recipient );
		}
	}
	
	if (isset( $bcc )) {
		foreach ( (array) $bcc as $recipient) {
			if (!IsValidEmail( $recipient )) return false;
			$phpmailer->AddBCC( trim($recipient) );
		}
	}

	if (isset( $attachment )) {
		foreach ( (array) $attachment as $fname) {
			$phpmailer->AddAttachment( $fname );
		}
	}

	if (isset( $replyto )) {
//		reset( $replytoname );
		foreach ( (array) $replyto as $recipient) {
			$toname = ((list( $key, $value ) = each( $replytoname )) ? $value : '');
			if (!IsValidEmail( $recipient ) || !IsValidName( $toname )) return false;
			$phpmailer->AddReplyTo( $recipient, $toname );
		}
	}

	// Send!
	$mailssend = @$phpmailer->Send();
	
	if( $phpmailer->error_count > 0 ) {
//		echo $phpmailer->ErrorInfo.'<br />';
	}

	return $mailssend;
}

function encoding(){
if (headers_sent() || connection_aborted() || !function_exists('ob_gzhandler') || ini_get('zlib.output_compression')) return 0;
if (strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'x-gzip') !== false) return "x-gzip"; 
if (strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip') !== false) return "gzip"; 
return 0; 
}

/**
 * Gzip encodes text to a specified level
 *
 * @param string The string to encode
 * @param int The level (1-9) to encode at
 * @return string The encoded string
*/
function GzipOut($USE_GZIP=1, $level=1){
if (! $USE_GZIP) {ob_end_flush(); return;}

if ($ENCODING = encoding()){
	$Contents = ob_get_contents(); 
	ob_end_clean(); 

	header("Content-Encoding: $ENCODING"); 

	$Contents = gzencode($Contents, $level);
	echo $Contents;
	exit; 

}else{
	ob_end_flush(); 
	exit;
}}

function text_wrap($utf8_string, $limit = 65) {

	$strlen = strlen($utf8_string);
	if($strlen<$limit)
		for($i = 0,$charlen = 0; $i < $strlen ; $i++,$charlen++) {
			$value = ord($utf8_string[$i]);
			if($value > 127) {
				if($value >= 192 && $value <= 223) $i++;
				elseif($value >= 224 && $value <= 239) $i += 2;
				elseif($value >= 240 && $value <= 247) $i += 3;
				else {}//'Not a UTF-8 compatible string'
			}
		}
	else for($i = 0,$charlen = 0; $charlen < $limit ; $i++,$charlen++) {
		$value = ord($utf8_string[$i]);
		if($value > 127) {
			if($value >= 192 && $value <= 223) $i++;
			elseif($value >= 224 && $value <= 239) $i += 2;
			elseif($value >= 240 && $value <= 247) $i += 3;
			else {}//'Not a UTF-8 compatible string'
		}
	}
	
	if($utf8_string[$i]!='' && $utf8_string[$i]!=' '){
		$text = substr( $utf8_string,0,$i - 4 );
		$text = substr( $text,0,strrpos($text,' ') ).' ...';
	}else $text = substr( $utf8_string,0,$i );
    return $text;
}

class Logging{
    // define default log file
    var $dir = '/cache/';
    // define file pointer
    var $fp = null;
    // set log file name
    function Logging($fname) {
		global $Config_root_dir;
        $this->log_file = $Config_root_dir.$this->dir.$fname.'.log';
    }
    // write message to the log file
    function lwrite($message){
        // if file pointer doesn't exist, then open log file
        if (!$this->fp) $this->lopen();
        // define current time
        $time = date('[d-M-Y H:i:s O]');
        // write to the log file
        fwrite($this->fp, "$time $message\n");
    }
    // open log file
    function lopen(){
        // define log file path and name
        $lfile = $this->log_file;
        // open log file for writing only; place the file pointer at the end of the file
        // if the file does not exist, attempt to create it
        $this->fp = fopen($lfile, 'a') or exit("Can't open $lfile!");
    }
	function lclose() {
		fclose($this->fp);
	}
}
if (!function_exists('file_put_contents')) {
    function file_put_contents($filename, $data) {
        $f = @fopen($filename, 'w');
        if (!$f) {
            return false;
        } else {
            $bytes = fwrite($f, $data,strlen($data));
            fclose($f);
            return $bytes;
        }
    }
}
function mygzdecode($data){
	global $Config_root_dir;
	$g=tempnam($Config_root_dir.'/cache','gz');
	file_put_contents($g,$data);
	$decode = implode('',gzfile($g));
	@unlink($g);
	return $decode;
}
function Message($state,$output,$texts/*,$report=true*/){
	global $LANG;
	$ok_code	= '<div id="mess" class="green"><img src="../data/images/ok.gif" width="16" height="16" border="0" /> ';
	$err_code	= '<div id="mess" class="red"><img src="../data/images/error.gif" width="16" height="16" border="0" /> ';
	if($output=='printf' || $output=='sprintf')
		$translated = vsprintf($LANG->_(array_shift($texts)),$texts);
	else foreach( (array) $texts as $text)
		$translated .= $LANG->_($text);

	//if($report){}
	$translated = ($state=='error')? $err_code.$translated.'</div>':$ok_code.$translated.'</div>';
	switch($output){
		case 'return':
		case 'sprintf':
			return $translated;
		case 'die':
			die($translated);
		default:
			print($translated);
	}
}
?>