<?php 
if ( is_dir('install') ) exit(header('location: warning.php?err=install'));

@session_start();
define( '_VALID', 1 );
require_once('engine/connect.php');
if($Config_use_statistic=='1'){
	include_once('engine/classes/class_statistic.php');
	$counter	=	new statistic();
	$counter->add();
}

switch($Config_cache_type){
	case 'files':
		include_once('engine/classes/class_diskCache.php');
		new diskCache();
	break;
	case 'mysql':
		include_once('engine/classes/class_mysqlCache.php');
		new mysqlCache();
	break;
}
//page not chached and generate new page
@header('Content-Type: text/html; charset=utf-8');

//state offline for every user except master admin
if (! (isset($_SESSION['admin_id']) && @$_SESSION['admin_type'] == 'administrator') ){
	if ( $Config_offline == '1' ){
		if(file_exists('cache/offline.htm')){
			include('cache/offline.htm');
			exit;
		}else exit(header('location: '.$Config_live_site.'/warning.php?err=offline'));
	}
}
require_once('engine/classes/class_showlinks.php');
if( isset($_GET['group']) ){
	include_once('engine/classes/class_singleGroup.php');
	$gid = (int) $_GET['group'];
	$links		=	new singleGroup($gid);
}else{
	$links		=	new showlinks();
	$links->numGroupShowed = (int)$_GET['g'];
}

require_once('engine/classes/class_showadverts.php');
$advert		=	new showadverts();

require_once('engine/extrapages.php');
$clr = color_skin();

if( isset($_GET['group']) )	include_once('cache/single.tpl');
else include_once('cache/index.tpl');
?>